﻿Imports System.Net

Public Class Form1
    Private idHry As Integer
    Private pocetTahu As Integer
    Private mapa As List(Of List(Of IPolicko))
    Private ja As New Hrac()
    Private protivnik As New Nepritel()
    Private lastPaint
    Private pocetTahuNaZacatku As Integer = -1

    Private Sub btnStart_Click(sender As System.Object, e As System.EventArgs) Handles btnStart.Click
        LoadStandartOutput(command("start"))
        btnStart.Text = "Restart"
    End Sub

    Private Function command(address) As String
        Dim wc As New WebClient()
        Return wc.DownloadString(String.Format("{0}/{1}", txtServer.Text, address))
    End Function

    Private Sub printMap(lines As List(Of String))
        lastPaint = lines
        Dim g = PictureBox1.CreateGraphics()
        mapa = New List(Of List(Of IPolicko))
        For y = 0 To 9
            mapa.Add(New List(Of IPolicko))

            For x = 0 To 9
                Dim char1 = lines(y).Trim()(x * 2)
                Dim char2 = lines(y).Trim()(x * 2 + 1)
                Dim sequence = char1 & char2

                Select Case sequence
                    Case "++"
                        mapa(y).Add(New MojeZakladna())
                    Case "--"
                        mapa(y).Add(New TvojeZakladna())
                    Case ".."
                        mapa(y).Add(New VolnePolicko())
                    Case "XX"
                        mapa(y).Add(New Zed())
                    Case Else
                        mapa(y).Add(New Poklad(sequence))
                End Select
                mapa(y)(x).NakresliSe(x, y, g)
            Next

        Next
        ja.NakresliSe(g)
        If Not IsNothing(protivnik) Then
            protivnik.NakresliSe(g)
        End If
    End Sub

    Private Sub Form1_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        If Not IsNothing(lastPaint) Then
            printMap(lastPaint)
        End If
    End Sub

    Private Sub btnPohyb_Click(sender As Button, e As System.EventArgs) Handles btnUp.Click, btnRight.Click, btnLeft.Click, btnDown.Click
        Dim output = command(String.Format("tah?id={0}&pohyb={1}", idHry, sender.Tag))
        LoadStandartOutput(output)
    End Sub

    Private Sub LoadStandartOutput(output As String)
        Dim lines As Object = output.Split(New Char() {vbCrLf}, System.StringSplitOptions.RemoveEmptyEntries).ToList()
        Try
            idHry = lines(0)
        Catch ex As Exception
            MessageBox.Show(lines(0))
            idHry = Nothing
            mapa.Clear()
            pocetTahu = 0
            ja = New Hrac()
            protivnik = New Nepritel()
            lastPaint = Nothing
            validButtons()
            pocetTahuNaZacatku = -1
            btnStart.Text = "Start"
            lblTahy.Text = "Tahy došly"
            Return
        End Try
        pocetTahu = lines(1)
        If Me.pocetTahuNaZacatku = -1 Then
            pocetTahuNaZacatku = pocetTahu
        End If
        lines.RemoveAt(0)
        lines.RemoveAt(0)

        Dim lastVals = lines(10)
        ja.nactiData(lastVals)
        Try
            lastVals = lines(11)
            protivnik.nactiData(lastVals)
        Catch ex As Exception
            protivnik = Nothing
        End Try


        lines.RemoveAt(lines.Count - 1)
        lines.RemoveAt(lines.Count - 1)
        lines.RemoveAt(lines.Count - 1)

        lblNeses.Text = String.Format("Neseš = {0}", ja.poklad)
        lblScore.Text = String.Format("Score = {0}", ja.score)
        lblTahy.Text = String.Format("Tahů {0}/{1}", pocetTahu, pocetTahuNaZacatku)

        printMap(lines)
        validButtons()
    End Sub

    Public Sub validButtons()
        ' ty cathce jsou tu kvůli úpřetečení mimo mapu, kde index v mapě nebude existovat
        Try
            btnUp.Enabled = mapa(ja.y - 1)(ja.x).MuzesJitNa()
        Catch ex As Exception
            btnUp.Enabled = False
        End Try

        Try
            btnDown.Enabled = mapa(ja.y + 1)(ja.x).MuzesJitNa()
        Catch ex As Exception
            btnDown.Enabled = False
        End Try

        Try
            btnLeft.Enabled = mapa(ja.y)(ja.x - 1).MuzesJitNa()
        Catch ex As Exception
            btnLeft.Enabled = False
        End Try

        Try
            btnRight.Enabled = mapa(ja.y)(ja.x + 1).MuzesJitNa()
        Catch ex As Exception
            btnRight.Enabled = False
        End Try
    End Sub

End Class
